#encoding: utf-8
module AttributeFieldsHelper
  include ActionView::Helpers::FormTagHelper
  include ActionView::Helpers::FormOptionsHelper
  include ActionView::Helpers::DateHelper
  include ActionView::Helpers::TagHelper
  include ActionView::Helpers::RenderingHelper
  include ActionView::Context
  include OrbitBasis::RenderAnywhere

  include OrbitFormHelper

  def block_helper(user,index,disable = false)
    unless self.disabled
      @index = index
      @markup_options = markup_options.merge(:disabled=>disable,:func=>"input_unit")
      @user = user
      @attribute_value = @user.get_value_from_field_id(id)
      @new_attribute = @attribute_value.nil?  
      @attribute_value = @attribute_value || @user.attribute_values.build( attribute_field_id: id )
      @prefiled_value = @attribute_value.value
      @panel_setting = self.get_data
      return instance_eval("render_#{markup}") #rescue ""

    end
  end

  def lang_tab(str,lang)
      content_tag(:div,str,:class=>"tab-pane fade",:id=>(get_field_name_base+"tab_#{lang}"))
  end

  def render_address
    control_group_wrapper do |key,value|
      value = (can_muti_lang_input? ?  @prefiled_value[key] : @prefiled_value) rescue nil
      key_field = can_muti_lang_input? ? "[#{key}]" : ""
      place_holder= @panel_setting["placeholder"][key] rescue ''
      # result = text_area_tag(get_field_name_base + key_field,  value,@markup_options.merge({:placeholder=>place_holder,:for=>key}))
      result = text_field_tag(get_field_name_base + key_field,  value,@markup_options.merge({:placeholder=>place_holder,:for=>key}))

      add_ext= @attribute_value.address_ext[key] rescue {}

      result << hidden_field_tag(get_basic_field_name_base+"[address_ext][#{key}][county]",add_ext["county"],:class=>"county_#{key}")
      result << hidden_field_tag(get_basic_field_name_base+"[address_ext][#{key}][street_address]",add_ext["street_address"],:class=>"street_address_#{key}")
      result << hidden_field_tag(get_basic_field_name_base+"[address_ext][#{key}][city]",add_ext["city"],:class=>"city_#{key}")
      result << hidden_field_tag(get_basic_field_name_base+"[address_ext][#{key}][zip]",add_ext["zip"],:class=>"zip_#{key}")
      result << hidden_field_tag(get_basic_field_name_base+"[address_ext][#{key}][country]",add_ext["country"],:class=>"country_#{key}")
      result << hidden_field_tag(get_basic_field_name_base+"[address_ext][#{key}][indicator]",add_ext["indicator"],:class=>"indicator_#{key}")
    end
  end

  def render_checkbox
     @prefiled_value ||=[]
    control_group_wrapper do 
      a = self[:option_list].collect do |key,value|
        label_tag(key,check_box_tag(get_field_name_base+"[#{key}]", true ,  (@prefiled_value.include?(key) ? true : false), {})+value[I18n.locale.to_s],@markup_options.merge(:class=>"checkbox inline"))
      end.join rescue ""
    end
  end

  def render_date 
    
    d = DateTime.now()

    if date_is_range?
      # fill_from = @attribute_value.get_date(:from) rescue nil
      # fill_to = @attribute_value.get_date(:to) rescue nil
      control_group_wrapper do

      case self.typeC['format']
        when 'format1'
          fill_from = (@prefiled_value && @prefiled_value["from"] ) ? @prefiled_value["from"] : d.strftime("%Y/%m/%d %H:%M")
          fill_to = (@prefiled_value && @prefiled_value["to"] ) ? @prefiled_value["to"] : d.strftime("%Y/%m/%d %H:%M")
          buf = datetime_picker(get_field_name_base+'[from]', fill_from, 'yyyy/MM/dd hh:mm', true)
          buf << ' ~ '
          buf << datetime_picker(get_field_name_base+'[to]', fill_to, 'yyyy/MM/dd hh:mm', true)
        when 'format2'
          fill_from = (@prefiled_value && @prefiled_value["from"] ) ? @prefiled_value["from"] : d.strftime("%Y/%m/%d")
          fill_to = (@prefiled_value && @prefiled_value["to"] ) ? @prefiled_value["to"] : d.strftime("%Y/%m/%d")
          buf = datetime_picker(get_field_name_base+'[from]', fill_from, 'yyyy/MM/dd')
          buf << ' ~ '
          buf << datetime_picker(get_field_name_base+'[to]', fill_to, 'yyyy/MM/dd')
        when 'format3'
          fill_from = (@prefiled_value && @prefiled_value["from"] ) ? @prefiled_value["from"] : d.strftime("%Y/%m")
          fill_to = (@prefiled_value && @prefiled_value["to"] ) ? @prefiled_value["to"] : d.strftime("%Y/%m/")
          buf = datetime_picker(get_field_name_base+'[from]', fill_from, 'yyyy/MM')        
          buf << ' ~ '
          buf << datetime_picker(get_field_name_base+'[to]', fill_to, 'yyyy/MM')
        when 'format4'
          fill_from = (@prefiled_value && @prefiled_value["from"] ) ? @prefiled_value["from"] : d.strftime("%Y")
          fill_to = (@prefiled_value && @prefiled_value["to"] ) ? @prefiled_value["to"] : d.strftime("%Y")
          buf = datetime_picker(get_field_name_base+'[from]', fill_from, 'yyyy')  
          buf << ' ~ '
          buf << datetime_picker(get_field_name_base+'[to]', fill_to, 'yyyy')
        end

        # buf = date_select(get_field_name_base+'[from]',nil,@markup_options.merge(:default=>fill_from),:class=>"input-small")
        # buf << ' ~ '
        # buf << date_select(get_field_name_base+'[to]',nil,@markup_options.merge(:default=>fill_to),:class=>"input-small")
        buf
      end
    else
      # @prefiled_value = @attribute_value.get_date
      # @prefiled_value = @attribute_value.get_date

      case self.typeC['format']
        when 'format1'
          tmp = datetime_picker(get_field_name_base, (@prefiled_value ? @prefiled_value : d.strftime("%Y/%m/%d %H:%M")), 'yyyy/MM/dd hh:mm', true)
        when 'format2'
          tmp = datetime_picker(get_field_name_base, (@prefiled_value ? @prefiled_value : d.strftime("%Y/%m/%d")), 'yyyy/MM/dd')
        when 'format3'
          tmp = datetime_picker(get_field_name_base, (@prefiled_value ? @prefiled_value : d.strftime("%Y/%m")), 'yyyy/MM')        
        when 'format4'
          tmp = datetime_picker(get_field_name_base, (@prefiled_value ? @prefiled_value : d.strftime("%Y")), 'yyyy')  
        end
      
      control_group_wrapper{tmp} 
      # control_group_wrapper{date_select(get_field_name_base,nil,@markup_options.merge(:default=>@prefiled_value),:class=>"input-small")} 

    end
  end

  def datetime_picker(object_name, value, format, time=false)
    content_tag :div, :class => "input-append datetimepick", "data-date-format"=>format, "data-picktime"=>"#{time}" do
      concat text_field_tag(object_name, value, :placeholder=>format)
      concat (content_tag :span, :class => 'add-on clearDate' do
                content_tag :i, nil, :class => 'icons-cross-3'
              end)
      concat (content_tag :span, :class => 'add-on iconbtn' do
                content_tag :i, nil, 'data-time-icon' => 'icons-clock', 'data-date-icon' => 'icons-calendar', :class=>"icons-calendar"
              end)
    end
  end

  def render_date_durnation #Need re-write low priority
    
  end

  def render_radio_button 
     @prefiled_value ||=[]
    control_group_wrapper do
      self[:option_list].collect do |key,value|
        label_tag(key,radio_button_tag(get_field_name_base, key ,  (@prefiled_value.include?(key) ? true : false), {})+value[I18n.locale.to_s],@markup_options.merge(:class=>"radio inline"))
      end.join 
    end
  end

  def render_select 
    prompt = @panel_setting["initial"][I18n.locale.to_s] rescue nil
    @markup_options.merge!(:prompt => prompt) unless prompt.nil?
    control_group_wrapper{select_tag( get_field_name_base,options_for_select(self.option_list.collect{|p| [p[1][I18n.locale.to_s],p[0]]},@prefiled_value),@markup_options)} rescue ""
  end

  def render_text_area 
     control_group_wrapper do |key,value|
      value = can_muti_lang_input? ?  @prefiled_value[key] : @prefiled_value
      key = can_muti_lang_input? ? "[#{key}]" : ""
      place_holder= @panel_setting["placeholder"][I18n.locale.to_s] rescue ''
      text_area_tag(get_field_name_base + key,  value,@markup_options.merge(:placeholder=>place_holder))
    end
  end

  def render_text_field
      a = control_group_wrapper do |key,value|
        add_more_blank = can_add_more ? "[]" : ""
        key_field = can_muti_lang_input? ? "[#{key}]" : ""
        place_holder= @panel_setting["placeholder"][key] rescue ''
        text_field_tag([get_field_name_base,add_more_blank,key_field].join,  value,@markup_options.merge(:placeholder=>place_holder))
      end  
  end

  def date_is_range?
    is_range =  "false"
    data = get_data
    if !data.nil?
      is_range = data['is_range'] if data.has_key? "is_range"  
    end
    is_range == "true" 
  end

protected

  def lang_panel_tabbable_wrapper(add_more_params,&block)
    add_more_counter = ''

    if self.markup=='text_area' #or self.markup=='address' 

      tmp1 = VALID_LOCALES.collect do |key|
        value = @prefiled_value[key]  rescue nil
        # div_class_ary = ["tab-pane" ,"fade","#{get_pairing_tab_class({})}_#{key}"]
        div_class_ary = ["tab-pane" ,"fade"]

        div_id = "#{get_pairing_tab_class({})}_#{key}"

        if can_add_more
          add_more_value = add_more_params[0][:value]
          add_more_counter = add_more_params[0][:counter]
          value = add_more_value[key] rescue nil
          div_class_ary << "add_more_item_#{add_more_counter}"
        end

        div_class = div_class_ary.join(" ")
        div_class << (key == I18n.locale.to_s ?  " active in" : '')
        content_tag(:div,yield(key,value), :id=>div_id,:class=>div_class)
      end# of VALID_LOCALES.collect for tabed input


      tmp2 = content_tag(:div,:class => 'btn-group', :data=>{:toggle=>"buttons-radio"}) do 
        buff2 = VALID_LOCALES.each.collect do |key|
            # link_entry = self.add_more ? "#{add_more_tab(:tab_btn,loop_counter,key)}" : "#tab"+id.to_s+"_#{key}"
            link_entry_ary = ["##{get_pairing_tab_class({})}","_#{key}"]
            link_entry_ary << ".add_more_item_#{add_more_counter}" if can_add_more
            link_entry = link_entry_ary.join
            link_to(I18nVariable.from_locale(key),link_entry,:data=>{:toggle=>"tab"},:class=>"btn #{(key == I18n.locale.to_s ?  "active" : nil)}",:for=>key)
        end  # of VALID_LOCALES.collect for tabs

        buff2 << link_to((content_tag :i,'',:class=>'icon-edit'),"##{get_pairing_tab_class({})}_m_window", :role=>"button",:class=>'btn',:data=>{:toggle=>"modal"}) if self.markup == 'address'
        buff2 << link_to((content_tag :i,'',:class=>'icon-trash'),"#",:class=>"btn remove-input") if self.add_more
        buff2.join.html_safe
      end # of content ul

        
      tmp = content_tag :div,:class=> "tab-content textarea-lang" do
        tmp2 << tmp1.join('').html_safe
      end

    else

      # tmp = content_tag :div,:class=> (add_more || self.markup=='address') ?  "input-append" : "tab-content" do
      tmp1 = 
        content_tag :div,:class=> "tab-content" do

          buff = VALID_LOCALES.collect do |key|
            value = @prefiled_value[key]  rescue nil
            # div_class_ary = ["tab-pane" ,"fade","#{get_pairing_tab_class({})}_#{key}"]
            div_class_ary = ["tab-pane" ,"fade"]

            div_id = "#{get_pairing_tab_class({})}_#{key}"


            if can_add_more
              add_more_value = add_more_params[0][:value]
              add_more_counter = add_more_params[0][:counter]
              value = add_more_value[key] rescue nil
              div_class_ary << "add_more_item_#{add_more_counter}"
            end

            div_class = div_class_ary.join(" ")
            div_class << (key == I18n.locale.to_s ?  " active in" : '')
            content_tag(:div,yield(key,value), :id=>div_id,:class=>div_class)
          end# of VALID_LOCALES.collect for tabed input

          buff.join('').html_safe

        end

      tmp2 = content_tag(:div,:class => 'btn-group', :data=>{:toggle=>"buttons-radio"}) do 
        buff2 = VALID_LOCALES.each.collect do |key|
            # link_entry = self.add_more ? "#{add_more_tab(:tab_btn,loop_counter,key)}" : "#tab"+id.to_s+"_#{key}"
            link_entry_ary = ["##{get_pairing_tab_class({})}","_#{key}"]
            link_entry_ary << ".add_more_item_#{add_more_counter}" if can_add_more
            link_entry = link_entry_ary.join
            link_to(I18nVariable.from_locale(key),link_entry,:data=>{:toggle=>"tab"},:class=>"btn #{(key == I18n.locale.to_s ?  "active" : nil)}",:for=>key)
        end  # of VALID_LOCALES.collect for tabs

        buff2 << link_to((content_tag :i,'',:class=>'icon-edit'),"#address-field", :role=>"button",:class=>'btn',:data=>{:toggle=>"modal"}) if self.markup == 'address'
        buff2 << link_to((content_tag :i,'',:class=>'icon-trash'),"#",:class=>"btn remove-input") if self.add_more
        buff2.join.html_safe
      end # of content ul


        
      tmp = content_tag :div,:class=> "input-append" do
        tmp1 << tmp2
      end

      # tmp << content_tag(:ul,:class=> 'nav nav-pills') do 
      #   VALID_LOCALES.each.collect do |key|
      #       # link_entry = self.add_more ? "#{add_more_tab(:tab_btn,loop_counter,key)}" : "#tab"+id.to_s+"_#{key}"
      #       link_entry_ary = [".#{get_pairing_tab_class({})}",".#{key}"]
      #       link_entry_ary << ".add_more_item_#{add_more_counter}" if can_add_more
      #       link_entry = link_entry_ary.join
      #       content_tag(:li,link_to(I18nVariable.from_locale(key),link_entry,:data=>{:toggle=>"tab"}),:class=>(key == I18n.locale.to_s ?  "active" : nil),:for=>key)
      #   end.join.html_safe  # of VALID_LOCALES.collect for tabs
      # end # of content ul

    end

  end


  def controls_wrapper(*add_more_params,&block)
      result = ''
      add_more_counter = ""

      if can_add_more
        add_more_counter = add_more_params[0][:counter] 
        add_more_value = add_more_params[0][:value]  
      end
    


    if can_muti_lang_input?
      result << lang_panel_tabbable_wrapper(add_more_params,&block)
      result << gen_modal_dialog if self.markup == "address"

      # result << add_more_unt if can_add_more
    else #cross lang field
      
      case can_add_more
       when true
         value = add_more_params[0][:value]  
         result << content_tag(:div,:class=>"input-append"){yield(nil,value) + link_to((content_tag :i,'',:class=>'icon-trash'),"#",:class=>"btn remove-input") }
         # result << add_more_unt
        else
         value = @prefiled_value
         result << yield(nil,value)
      end

      
    end

      result.html_safe

  end # of def controls_wrapper(&block)

  def control_group_wrapper(&block) 
    div_class = can_muti_lang_input? ? "control-group" : "control-group"
    # div_class = can_muti_lang_input? ? "control-group language-swich" : "control-group"
    result =""

    case self.markup

      when "text_field"

        if can_add_more

          multipleInputs  =  
            content_tag(:div,:class=>"add-target") do
              @attribute_value.add_more_counter.times.collect do |t|
               controls_wrapper(:value=>(@prefiled_value[t] rescue nil),:counter=>t,&block)
              end.join('').html_safe # of add_more fields
            end


          temp =  label + content_tag(:div, multipleInputs + add_more_unt, :class=>'controls add-input')
          
          result = content_tag(:div,temp,:class=>div_class)  

          # result =  label +  multipleInputs + add_more_unt
          # result = label + 一堆的輸入框(要用 multipleInput editMore 包起來)  + add_more btn + hidden_fields
        else
          temp = label + content_tag(:div, controls_wrapper(&block), :class=>'controls')
          result = content_tag(:div,temp,:class=>div_class)  
          
        end

      when "address"

        # address  = content_tag :div,:class=>"multipleInput editMore" do
        address  = content_tag :div,:class=>"control-group" do
            label + content_tag(:div, controls_wrapper(&block), :class=>'controls add-input')
        end # of div  multipleInput editMore

        result =  address

    else
      temp = label + content_tag(:div, controls_wrapper(&block), :class=>'controls')
      result = content_tag(:div,temp,:class=>div_class)  

    end
    
    result << end_block
    result.html_safe

  end


  def add_more_unt    
    temp_field_name =  get_basic_field_name_base + '[temp]'
    add_more = content_tag :p,:class=> 'add-btn' do
        content = link_to (content_tag :i,I18n.t(:add),:class=>"icon-plus"),"#","data-roles"=>"role_a",:class=>"trigger #{can_muti_lang_input? ? 'textLengInput' : 'textInput' } btn btn-small btn-primary"
        content << hidden_field_tag("#{temp_field_name}[count]",@attribute_value.add_more_counter ,:class=>"list_count")
        content << hidden_field_tag("#{temp_field_name}[count]",get_basic_field_name_base,:class=>"field_name")
        content
    end # of div
    # add_more = content_tag :div,:class=> 'controls' do
    #   content_tag :span,:class=> 'help-block' do
    #     content = link_to (content_tag :i,I18n.t(:add),:class=>"icon-plus-sign"),"#",:class=>'addinput'
    #     content << hidden_field_tag("#{temp_field_name}[count]",@attribute_value.add_more_counter ,:class=>"list_count")
    #     content << hidden_field_tag("#{temp_field_name}[count]",get_basic_field_name_base,:class=>"field_name")
    #     content
    #   end # of span
    # end # of div
  end

  def end_block
    if @new_attribute
      hidden_field_tag(get_basic_field_name_base+"[attribute_field_id]",id,:for=>"field_#{@index}")
    else
      hidden_field_tag(get_basic_field_name_base+"[id]",@attribute_value.id,:for=>"field_#{@index}")
    end
  end

  def add_more_tab(mode,counter,key)
    case mode
    when :input_field
      get_pairing_tab_class(:suffix=>['','tab'+counter.to_s,key].join('-'))
    when :tab_btn
      ".#{get_pairing_tab_class(:suffix=>['','tab'+counter.to_s,key].join('-'))}"
    end
  end

  def get_pairing_tab_class(opts)
    prefix = opts[:prefix]
    suffix = opts[:suffix]
    str = get_basic_field_name_base.gsub("[","_").gsub("]",'')
    str = prefix.nil? ? str : prefix+ str 
    suffix.nil? ? str : str + suffix
  end

  def get_basic_field_name_base
    if @new_attribute
      "user[new_attribute_values][#{@index}]"
    else
      "user[attribute_values][#{@index}]"
    end
  end

  def get_field_name_base
    get_basic_field_name_base + "[value]"
  end

  def label
    label_tag(key,title,:class=>"control-label muted",:func => "field_label")
  end

  def can_muti_lang_input?
    if self.markup == "address"
      return true
    else
      LIST[:markups][markup]["muti_lang_input_supprt"] and !(get_data["cross_lang"] == "true")  
    end
  end

  def can_add_more
    if self.markup == "address"
      return false
    else
      add_more
    end
  end

  def gen_modal_dialog
    render_anywhere("shared/attribute_field/address_modal_dialog",{
        :field_name=>title,
        :html_id=>"address-field",
        :btn_class => "#{get_pairing_tab_class({})}",
        :field_name_basic => get_basic_field_name_base
          }
        )
  end

end